//
//  RootViewController.m
//  test6
//
//  Created by Paul on 7/30/08.
//  Copyright 2008 DINS. All rights reserved.
//

#import "RootViewController.h"
#import "FirstViewController.h"
#import "SecondViewController.h"


@implementation RootViewController

@synthesize firstViewController;
@synthesize secondViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil 
{
	if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) 
	{
		// Initialization code
	}
	return self;
}

- (void)viewDidLoad 
{
    FirstViewController *viewController = [[FirstViewController alloc] initWithNibName:@"FirstView" bundle:nil];
    viewController.rootViewController = self;
    self.firstViewController = viewController;
    [viewController release];
    
    [self.view addSubview:self.firstViewController.view];
}


- (void)loadSecondViewController 
{
    SecondViewController *viewController = [[SecondViewController alloc] initWithNibName:@"SecondView" bundle:nil];
    self.secondViewController = viewController;
    secondViewController.rootViewController = self;
    [viewController release];
}

- (IBAction)onView:(id)sender 
{	
	if( secondViewController == nil) 
	{
		[self loadSecondViewController];
	}
	
	UIView *mainView = firstViewController.view;
	UIView *flipsideView = secondViewController.view;
	
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:1];
	[UIView setAnimationTransition:([mainView superview] ? UIViewAnimationTransitionFlipFromRight : UIViewAnimationTransitionFlipFromLeft) forView:self.view cache:YES];
	
	if ([mainView superview] != nil) 
	{
		[secondViewController viewWillAppear:YES];
		[firstViewController viewWillDisappear:YES];
		[mainView removeFromSuperview];
		[self.view addSubview:flipsideView];
		[firstViewController viewDidDisappear:YES];
		[secondViewController viewDidAppear:YES];
		
	} 
	else 
	{
		[firstViewController viewWillAppear:YES];
		[secondViewController viewWillDisappear:YES];
		[flipsideView removeFromSuperview];
		[self.view addSubview:mainView];
		[secondViewController viewDidDisappear:YES];
		[firstViewController viewDidAppear:YES];
	}
	
	[UIView commitAnimations];
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)dealloc 
{
    [firstViewController release];
    [secondViewController release];
	[super dealloc];
}


@end
